"""bunny_collector.py

Part of the "first demo game" from the original Gummworld. Reimplemented in
Gummworld2.

This file is in the Public Domain. No warranties, no restrictions.
"""

import pygame

from gummworld2 import pygame_utils, data, State, Vec2d

from bunny import Bunny


class BunnyCollector(pygame.sprite.Sprite):

    def __init__(self, position):
        super(BunnyCollector, self).__init__()
        self._position = Vec2d(0.0,0.0)
        self.image = pygame.surface.Surface((10,10))
        self.image.fill(pygame.Color('white'))
        self.rect = self.image.get_rect()
        self.half_size = Vec2d(self.rect.center)
        self.position = position
        self.loose = 0
        self.collected = 0
        
    @property
    def position(self):
        return self._position
    @position.setter
    def position(self, val):
        p = self._position
        p.x,p.y = float(val[0]),float(val[1])
        self.rect.center = int(round(p.x)), int(round(p.y))
        
    def hit(self, *sprites):
        for sprite in sprites:
            if isinstance(sprite, Bunny):
                sprite.kill()
                self.loose -= 1
                self.collected += 1
